### Work-around the fact that OpenSUSE/SLES _always_ defined both :-/
%if 0%{?sles_version} == 0
%undefine sles_version
%endif

Name: urbackup-server
Version: 1.4.14
Release: 3.1
Summary: Efficient Client-Server backup system for Linux and Windows

%if 0%{?suse_version}
Group: Productivity/Archiving/Backup
%endif
%if 0%{?el6}
Group: Backup Server
%endif
License: GPLv3
URL: http://urbackup.sourceforge.net/
Source0: %{name}-%{version}.tar.gz
Source1: %{name}.init

%if 0%{?suse_version}
Source2: %{name}-rpmlintrc
PreReq: %fillup_prereq
%endif

BuildRequires: gcc, gcc-c++

%if 0%{?rhel}%{?fedora}
BuildRequires: cryptopp-devel, fuse-devel
%endif
%if 0%{?suse_version}
BuildRequires: autoconf, automake, libtool, pkg-config, libcryptopp-devel, fuse-devel
%endif

%if 0%{?el7}%{?fedora}%{?suse_version}
BuildRequires: libcurl-devel
%endif


Requires: fuse, logrotate
%if 0%{?el7}%{?fedora}%{?suse_version}
Requires: libcurl, systemd
%endif
%if 0%{?rhel}%{?fedora}
Requires: cryptopp
%endif
%if 0%{?suse_version}
Requires: libcryptopp
%endif


Requires(pre)   : /usr/sbin/useradd
%if 0%{?el7}%{?fedora}%{?suse_version}
Requires(post)  : systemd
Requires(preun) : systemd
%endif
%if 0%{?el6}%{?el5}
Requires(post)  : /sbin/chkconfig
Requires(preun) : /sbin/chkconfig
Requires(preun) : /sbin/service
%endif


%description
Efficient Client-Server Backup system for Linux and Windows.
A client for Windows lets you backup open files and complete
partition images. Backups are stored to disks in a efficient
way (deduplication) on either Windows or Linux servers.

%prep
%setup -q -n %{name}-%{version}
sed -i '/^AM_CFLAG/ s/$/ $(SUID_CFLAGS)/' %{_builddir}/%{name}-%{version}/Makefile.am
sed -i '/^AM_CFLAG/ s/$/ $(SUID_CFLAGS)/' %{_builddir}/%{name}-%{version}/cryptoplugin/Makefile.am
cd %{_builddir}/%{name}-%{version} && libtoolize --force --recursive && autoreconf --force --install

%build
export SUID_CFLAGS=-fPIE
%if 0%{?el7}%{?fedora}%{?suse_version}
%configure --enable-packaging  --with-mountvhd
%endif
%if 0%{?el6}%{?el5}
%configure --enable-packaging --without-mail --with-mountvhd
%endif


make %{?_smp_mflags}

%install
%make_install
mkdir -p %{buildroot}%{_sysconfdir}/sysconfig
mkdir -p %{buildroot}%{_initrddir}
mkdir -p %{buildroot}%{_unitdir}
mkdir -p %{buildroot}%{_mandir}/man1
mkdir -p %{buildroot}%{_sysconfdir}/logrotate.d/
%if 0%{?el7}%{?fedora}
mkdir -p %{buildroot}%{_prefix}/lib/firewalld/services
install -m 755 %{_builddir}/%{name}-%{version}/urbackup-server.service %{buildroot}%{_unitdir}/%{name}.service
install -m 640 %{_builddir}/%{name}-%{version}/urbackup-server-firewalld.xml %{buildroot}%{_prefix}/lib/firewalld/services/%{name}.xml
%endif
%if 0%{?el6}%{?el5}
install -m 755 %{SOURCE1} %{buildroot}%{_initrddir}/%{name}
%endif
%if 0%{?rhel}%{?fedora}
install -m 644 %{_builddir}/%{name}-%{version}/defaults_server %{buildroot}%{_sysconfdir}/sysconfig/%{name}
%endif
%if 0%{?suse_version}
mkdir -p %{buildroot}%{_localstatedir}/adm/fillup-templates/
install -m 644 %{_builddir}/%{name}-%{version}/defaults_server %{buildroot}%{_localstatedir}/adm/fillup-templates/sysconfig.%{name}
install -m 755 %{_builddir}/%{name}-%{version}/urbackup-server.service %{buildroot}%{_unitdir}/%{name}.service
%endif
install -m 644 %{_builddir}/%{name}-%{version}/docs/*.1 %{buildroot}%{_mandir}/man1
install -m 644 %{_builddir}/%{name}-%{version}/logrotate_urbackup_srv  %{buildroot}%{_sysconfdir}/logrotate.d/urbackup-server

%clean
rm -rf $RPM_BUILD_ROOT

%pre
getent group urbackup > /dev/null || groupadd -r urbackup
getent passwd urbackup > /dev/null || useradd -r -g urbackup -d %{_localstatedir}/urbackup \
 -s /sbin/nologin urbackup >/dev/null 2>&1
:

%post
/sbin/ldconfig
%if 0%{?suse_version}
%fillup_only
%service_add_post urbackup-server.service
%endif
%if 0%{?el7}%{?fedora}
%systemd_post urbackup-server.service
%endif

%preun
%if 0%{?el7}%{?fedora}
%systemd_preun urbackup-server.service
%endif
%if 0%{?suse_version}
%service_del_preun urbackup-server.service
%endif
%if 0%{?el6}%{?el5}
if [ $1 -eq 0 ]
then
  /sbin/service urbackup-server stop >/dev/null 2>&1 || :
  /sbin/chkconfig --del urbackup-server || :
fi
%endif

%postun
%if 0%{?el7}%{?fedora}
%systemd_postun_with_restart urbackup-server.service
%endif
%if 0%{?suse_version}
%service_del_postun urbackup-server.service
%endif
%if 0%{?el6}%{?el5}
if [ $1 -ge 1 ]
then
  /sbin/service urbackup-server condrestart >/dev/null 2>&1
fi
%endif
/sbin/ldconfig

%posttrans
%if 0%{?have_systemd}
if systemctl --quiet is-enabled %{name}.service 2>/dev/null
then 
   /bin/systemctl --quiet --force reenable %{name} 2>/dev/null || :
else 
   /bin/systemctl --quiet --force reenable %{name} 2>/dev/null || :
   /bin/systemctl --quiet disable %{name} 2>/dev/null || :
fi
%endif

%files
%defattr(-,root,root)
%doc AUTHORS COPYING ChangeLog README
%attr(4755,root,root) %{_bindir}/urbackup_snapshot_helper
%{_sbindir}/*
%{_libdir}/liburbackupserver*.so*
%{_mandir}/man1/*
%dir %attr(0755,urbackup,urbackup) %{_localstatedir}/urbackup
%attr(-,urbackup,urbackup) %{_localstatedir}/urbackup/*
%config(noreplace) %{_sysconfdir}/logrotate.d/urbackup-server
%if 0%{?suse_version}
%config %{_localstatedir}/adm/fillup-templates/sysconfig.%{name}
%else
%config(noreplace) %{_sysconfdir}/sysconfig/%{name}
%endif
%if 0%{?el7}%{?fedora}
%{_prefix}/lib/firewalld/services/%{name}.xml
%endif
%if 0%{?el7}%{?fedora}%{?suse_version}
%{_unitdir}/%{name}.service
%endif
%if 0%{?el6}%{?el5}
%{_initrddir}/urbackup-server
%endif
%exclude %{_libdir}/liburbackupserver*.la



%changelog
*Thu Mar 24 2016 Oleg Zaitsev <orionplatinum7@gmail.com> 1.4.14
- Updated to version 1.4.14

*Mon Jan 25 2016 Oleg Zaitsev <orionplatinum7@gmail.com> 1.4.12
- Updated to version 1.4.12

*Thu Oct 15 2015 Oleg Zaitsev <orionplatinum7@gmail.com> 1.4.10
- Updated to version 1.4.10
- Changed rights on urbackup_snapshot_helper

*Mon Sep 28 2015 Oleg Zaitsev <orionplatinum7@gmail.com> 1.4.9-1
- Updated to version 1.4.9

*Mon Sep 28 2015 Oleg Zaitsev <orionplatinum7@gmail.com> 1.4.9-1
- Updated to version 1.4.9

*Mon Mar 16 2015 Oleg Zaitsev <orionplatinum7@gmail.com> 1.4.8-1
- Updated to version 1.4.8

*Mon Jan 5 2015 Oleg Zaitsev <orionplatinum7@gmail.com> 1.4.7-1
- Updated to version 1.4.7
- Service definition for firewalld added to package

*Sun Dec 7 2014 Oleg Zaitsev <orionplatinum7@gmail.com> 1.4.6-2
- Several fixes in spec-file to enable build for OpenSUSE

*Tue Dec 02 2014 Oleg Zaitsev <orionplatinum7@gmail.com> 1.4.6-1
- Updated spec for version 1.4.6
- systemd unit provided by developer now
- Library path patch is in wrapper script now

*Mon Oct 06 2014 Oleg Zaitsev <orionplatinum7@gmail.com> 1.4.3-1
- Updated to version 1.4.3

*Fri Oct 03 2014 Oleg Zaitsev <orionplatinum7@gmail.com> 1.4.2-1
- Updated to version 1.4.2
- More macrofication
- systemd unit added

*Tue Sep 02 2014 Oleg Zaitsev <orionplatinum7@gmail.com> 1.4.0-1
- Upstream release 1.4.0
- libcurl dependency removed for EPEL <=6 (does not support mail function)
- manpages added to package

*Thu Aug 14 2014 Oleg Zaitsev <orionplatinum7@gmail.com> 1.4.0.752-2
- Added patches for 64-bit library paths

*Tue Aug 12 2014 Oleg Zaitsev <orionplatinum7@gmail.com> 1.4.0.744-1
- Initial build for Enterprise Linux
